var dot2val = require('dot2val');

var obj = {
    prop1: {
        arr: ['a', 'b', 'c']
      , str: 'Hello'
    }
  , prop2: {
        arr: [ { nested: 'Universe' } ]
      , str: 'Hello again!'
    }
}

var arr = [ { foo: 'bar' } ];

console.log(dot2val.get(obj, 'prop1.str')); // => "Hello"
console.log(dot2val.get(obj, 'prop1.arr.2')); // => "c"
console.log(dot2val.get(obj, 'prop2.arr.0.nested')); // => "Universe"

console.log(dot2val.get(undefined, 'doesnt.matter')); // => undefined
console.log(dot2val.get({}, 'doesnt.exist')); // => undefined
console.log(dot2val.get({}, 'doesnt.exist', 'default value')); // => "default value"

dot2val.set(obj, 'hello.universe', 'properties');
dot2val.set(obj, 'hello1', 'universe');
dot2val.set(obj, 'prop2');         // delete obj['prop2']
obj;;
